# Chapter1.py

'''
value
bit 0/1
byte 8 bit 00000000  
(128,64,32,16)(8,4,2,1)
10000001 <129>
char 01000001 A 01000010 B 01000011 C 
byte class
data type <string, int, boolean...>
int 10 <00001010>
string <Bob> B<01000010> o b

Collections of data -> Collection Class "INDEPENDENT" collections of sets of data
List [] mutable, indexed, dups
Sets {} !dups
Tuples () immutable
Dictionary/Map { key: value }
firstNames = ["Bob", "Joe", "Mary", 26, true, 12122025]

Level 3 Dimesional Data "DataFrames" "DEPENDENT" sets of data
pandas dataframe 
1 Dimension -> "Series" <col> -> value(Bob)   Excel ColA.2
2 Dimension -> <row/col> -> value(Bob) Excel Cell # A2<value>
pivot or pivottable
3 Dimension -> pivot1 <row/col> -> value(Bob) pivot<state> -> row/col
4 Dimension -> pivot2/pivot1 <row/col> -> value(Bob) p2<gender>p1<state>
... adding more pivots
'''

print("=== Importing data to a DataFrame ===")
# page 11
import pandas as pd  # pandas is a standard module that gets installed with python

# pages 11-27 pandas basics
# Step 1 -> import into a dataframe a dataset
fireDataFile = 'fires_by_month.xlsx'

df_fireData = pd.read_excel(fireDataFile) # ~9300

'''
print(dataframe) -> head() and tail() first and last 5 rows
head(10)
tail(8)
'''

print(df_fireData.tail(10))

print("=== Information about our DataFrame ===")
# info() -> schema
print( df_fireData.info() )
# 6 columns "Series" of data sets
# 9300 entries

# Series / column names
## column fires_by_month -> call column name [fires_by_month]
## IF column name has a space fires by month -> call 'fires by month'

# Add a new column to a dataframe called df_fireData
df_fireData['dollar_damage'] = 0
print(df_fireData.head())
print(df_fireData.info())
## or
# Generate a new dataFrame that has 6 cols from df_fireData and 1 new col called dollar_damage
# Step 1 -> make a copy of the source using the copy()
## fireData -> 7 cols (6 xlsx + 1)
df_fireData_dollarRebuilt = df_fireData.copy() # get the 7 cols exist
# Step 2 -> make your mods
df_fireData_dollarRebuilt['dollar_rebuilt'] = 0
print(df_fireData_dollarRebuilt.head())
print(df_fireData_dollarRebuilt.info())

# df_fireData_dollarRebuilt 8 cols
## !drop 5 cols -> parse 3 cols
df_fireData_dollarRebuilt_damageByState = df_fireData_dollarRebuilt[ 
    [
        'state',  # obj
        'dollar_damage', # float
        'dollar_rebuilt' # float
    ] # column List to copy to a new df
].copy()

print(df_fireData_dollarRebuilt_damageByState.head())


# Export our new dataframes to csv
df_fireData_dollarRebuilt.to_csv('firesData.csv', index=False)

# Create a new file for Chapter2.py -> import dataframes


# EOF Chapter1.py